#ifndef SUPERSCALER_H
#define SUPERSCALER_H

#include <vector>
#include <iostream>

#include "tuple.h"
#include "sparse_matrix.h"

#ifndef INSIGNIFICANT
#define INSIGNIFICANT 0.0000000001
#endif

namespace SuperScaler {
  class Filter {
  public:
    virtual double filter_size(double rate) = 0;
    virtual double filter(double dist) = 0;
    virtual ~Filter() {}
  };

  Filter *LanczosFilter(int lobes);

  template<typename T> T max(T a, T b) {
    if(a>b) return a;
    return b;
  }

  template<typename T> T min(T a, T b) {
    if(a<b) return a;
    return b;
  }

  Matrix<float> create_scaler(
    int input_size,
    float begin,
    float end,
    int output_size,
    Filter *filter);
};

#endif
